import {jsx as $4MPRY$jsx} from "react/jsx-runtime";
import {useRef as $4MPRY$useRef, useMemo as $4MPRY$useMemo, useContext as $4MPRY$useContext, useReducer as $4MPRY$useReducer, useCallback as $4MPRY$useCallback, useEffect as $4MPRY$useEffect, createContext as $4MPRY$createContext} from "react";



const $090815f5086f7f29$var$isObj = (obj)=>typeof obj === "object" && obj !== null && !Array.isArray(obj);
function $090815f5086f7f29$var$deepMerge(obj1, obj2) {
    if (obj2 === undefined) return obj1;
    if (!$090815f5086f7f29$var$isObj(obj1) || !$090815f5086f7f29$var$isObj(obj2)) return obj2;
    const obj = {
        ...obj1
    };
    for (const [key, value] of Object.entries(obj2))obj[key] = $090815f5086f7f29$var$deepMerge(obj[key], value);
    return obj;
}
function $090815f5086f7f29$var$useValueRef(value) {
    const ref = (0, $4MPRY$useRef)(value);
    if (ref.current !== value) ref.current = value;
    return ref;
}
function $090815f5086f7f29$var$useMemoValue(value) {
    const ref = (0, $4MPRY$useRef)(value);
    return (0, $4MPRY$useMemo)(()=>{
        if (JSON.stringify(value) !== JSON.stringify(ref.current)) ref.current = value;
        return ref.current;
    }, [
        value
    ]);
}
function $090815f5086f7f29$var$createProvider(ctx) {
    return function Provider({ config: config , children: children  }) {
        return /*#__PURE__*/ (0, $4MPRY$jsx)(ctx.Provider, {
            value: config,
            children: children
        });
    };
}
function $090815f5086f7f29$var$reducer(state, action) {
    return {
        ...state,
        ...action
    };
}
const $090815f5086f7f29$var$defaultResult = {
    loading: false,
    data: undefined,
    error: undefined
};
function $090815f5086f7f29$var$createUseLazyApi(ctx, apis) {
    return function useLazyApi(key, defaultOpts = {}) {
        const defaultOptsRef = $090815f5086f7f29$var$useValueRef(defaultOpts);
        const api = apis[key];
        const { fetcher: fetcher  } = (0, $4MPRY$useContext)(ctx);
        const [result, setResult] = (0, $4MPRY$useReducer)($090815f5086f7f29$var$reducer, $090815f5086f7f29$var$defaultResult);
        const fetch = (0, $4MPRY$useCallback)(async (opts = {})=>{
            const { variables: variables = {}  } = $090815f5086f7f29$var$deepMerge(defaultOptsRef.current, opts);
            setResult({
                loading: true
            });
            let data = null, error = null;
            try {
                data = await fetcher(api, variables);
            } catch (err) {
                error = err;
            }
            setResult({
                loading: false,
                data: data,
                error: error
            });
            return {
                data: data,
                error: error
            };
        }, [
            fetcher,
            api,
            setResult
        ]);
        return [
            fetch,
            {
                ...result,
                refetch: fetch
            }
        ];
    };
}
function $090815f5086f7f29$var$createUseMutationApi(ctx, apis) {
    const useLazyApi = $090815f5086f7f29$var$createUseLazyApi(ctx, apis);
    return function useMutationApi(key, opts = {}) {
        return useLazyApi(key, opts);
    };
}
function $090815f5086f7f29$var$createUseApi(ctx, apis) {
    const useLazyApi = $090815f5086f7f29$var$createUseLazyApi(ctx, apis);
    return function useApi(key, opts = {}) {
        const [fetch, result] = useLazyApi(key, opts);
        const latestVariables = $090815f5086f7f29$var$useMemoValue(opts.variables);
        (0, $4MPRY$useEffect)(()=>{
            fetch();
        }, [
            fetch,
            latestVariables
        ]);
        return result;
    };
}
const $090815f5086f7f29$var$missingFetcher = async ()=>{
    throw new Error("Missing fetcher!");
};
function $090815f5086f7f29$export$1f41eb08414e9201(apis) {
    const ctx = /*#__PURE__*/ (0, $4MPRY$createContext)({
        fetcher: $090815f5086f7f29$var$missingFetcher
    });
    return {
        Provider: $090815f5086f7f29$var$createProvider(ctx),
        useLazyApi: $090815f5086f7f29$var$createUseLazyApi(ctx, apis),
        useMutationApi: $090815f5086f7f29$var$createUseMutationApi(ctx, apis),
        useApi: $090815f5086f7f29$var$createUseApi(ctx, apis)
    };
}


export {$090815f5086f7f29$export$1f41eb08414e9201 as createAPIs};
//# sourceMappingURL=module.js.map
